// background.js
console.log('我是后台js...');
//
function util_isnumber(val){
    var regPos = /^[0-9]+.?[0-9]*/; //判断是否是数字。
    if(regPos.test(val) ){
        return true;
    }else{
        return false;
    }
}

function extractEmails (text) {
    text = text.replaceAll('<b>', '').replaceAll('</b>', '');
    return text.match(/([a-zA-Z0-9._-]+@[a-zA-Z0-9._-]+\.[a-zA-Z0-9._-]+)/gi);
}

function selectPhoneNumber(str) {
    const phoneReg = /(1[0-9]{10})|([0-9]{3,4})?[0-9]{7,12}/g;//匹配手机号或者固话
    const num = str.replace(/\s|[(]|[)]|[（]|[）]|[-]*/g, '');//去除字符串中所有空格、小括号和横杠
    const phone_arr = num.match(phoneReg);//识别手机号或者固话（在字符串内检索指定的值，或找到一个或多个正则表达式的匹配）
    let phone = '';
    if(phone_arr && phone_arr.length > 0){
        for(let i=0;i<phone_arr.length;i++){
            phone = phone_arr[i];
            if(phone.indexOf('86') != -1 || phone.indexOf('0755') != -1){
                break;
            }
        }
    }
    return phone;
}

function get_phone(str=''){
    var $html = $(str);
    let phone = '';
    $html.find('a').each(function (){
        let _ahref = $(this).attr('href');
        if(_ahref && (_ahref.indexOf('tel') != -1 || _ahref.indexOf('phone') != -1) &&
            _ahref.indexOf('www') ==-1 && _ahref.indexOf('hotel') ==-1 &&
            _ahref.indexOf('Intellectual') ==-1 &&
            _ahref.indexOf('Patel') ==-1
        ){
            phone = $(this).text();
        }
    });
    //td中的phone
    if(phone == '' || !phone){
        $html.find('table td').each(function (){
                let _td_val = $(this).text();
                if((_td_val.indexOf('+86')!=-1 ||
                    _td_val.indexOf('Hotline') != -1 ||
                    _td_val.indexOf('fax') != -1 ||
                    _td_val.indexOf('mobile') != -1 ||
                    _td_val.indexOf('0086')!=-1 ||
                    _td_val.indexOf('86-0755')!=-1 ||
                    _td_val.indexOf('0755')!=-1 ||
                    _td_val.indexOf('tel')!=-1 ||
                    _td_val.indexOf('whatsapp') != -1 ||
                    _td_val.indexOf('phone') != -1 ||
                    _td_val.indexOf('专线')!=-1) && (_td_val.indexOf('hotel') ==-1 &&
                    _td_val.indexOf('Intellectual') ==-1 &&
                    _td_val.indexOf('Patel') ==-1)
                ){
                    phone = _td_val;
                }
        });
    }
    //
    if(phone == '' || !phone){
       $html.find('p').each(function (){
           let _p_text = $(this).text();
           if((_p_text.indexOf('tel') != -1 ||
               _p_text.indexOf('Hotline') != -1 ||
               _p_text.indexOf('fax') != -1 ||
               _p_text.indexOf('mobile') != -1 ||
               _p_text.indexOf('+86')!=-1 ||
               _p_text.indexOf('0086')!=-1 ||
               _p_text.indexOf('86-0755')!=-1 ||
               _p_text.indexOf('0755')!=-1 ||
               _p_text.indexOf('whatsapp') != -1 ||
               _p_text.indexOf('phone') != -1 ||
               _p_text.indexOf('专线')!=-1) && (_p_text.indexOf('hotel') ==-1 &&
                    _p_text.indexOf('Intellectual') ==-1 &&
                    _p_text.indexOf('Patel') ==-1)
           ){
               phone = _p_text;
           }
       });
    }
    //
    if(phone == '' || !phone){
       $html.find('li').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 &&
                    _div_text.indexOf('Intellectual') ==-1 &&
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
    //
    if(phone == '' || !phone){
       $html.find('span').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 &&
                    _div_text.indexOf('Intellectual') ==-1 &&
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
    //
    //
    if(phone == '' || !phone){
       $html.find('div').each(function (){
           let _div_text = $(this).text();
           if((_div_text.indexOf('tel') != -1 ||
               _div_text.indexOf('Hotline') != -1 ||
               _div_text.indexOf('fax') != -1 ||
               _div_text.indexOf('mobile') != -1 ||
               _div_text.indexOf('+86') != -1 ||
               _div_text.indexOf('0086') != -1 ||
               _div_text.indexOf('86-0755') != -1 ||
               _div_text.indexOf('0755')!=-1 ||
               _div_text.indexOf('whatsapp') != -1 ||
               _div_text.indexOf('phone') != -1 ||
               _div_text.indexOf('专线')!=-1) && (_div_text.indexOf('hotel') ==-1 ||
                    _div_text.indexOf('Intellectual') ==-1 ||
                    _div_text.indexOf('Patel') ==-1)
           ){
               phone = _div_text;
           }
       });
    }
     //
    if(phone == '' || !phone){
        phone = $html.find('.phone').text();
    }
    //排除一些
    if(phone){
        //去一些字符
        phone = phone.replace('https://api.whatsapp.com/send?phone=','');
        phone = phone.replace('{','');
        phone = phone.replace('}','');
        phone = phone.replace('Mobile：','');
        phone = phone.replace('Tel: ','');
        phone = phone.replace('手机：','');
        if(phone.indexOf('click')!=-1 || phone.indexOf('font-size')!=-1){
            phone = '';
        }
    }

    return phone;
}

function util_url_get_domain(url=''){
    url = url.replace('https://','');
    url = url.replace('http://','');
    url = url.replace('www.','');
    urlArr = url.split('/');
    if(urlArr.length>0){
        return urlArr[0];
    }
    return '';
}

function util_url_get_domain_host(url=''){
    domain = util_url_get_domain(url);
    if(domain){
        domainArr = domain.split('.');
        if(domainArr.length>1){
           var domain_may = domainArr[1];
           if(domain_may.length>=5){
               return domain_may;
           }else{
               return domainArr[0];
           }
        }else if(domainArr.length==1){
            return domainArr[0];
        }
    }
    return '';
}

function get_seller_id_from_url(seller_url=''){
    //https://www.amazon.com/gp/help/seller/at-a-glance.html/ref=dp_merchant_link?ie=UTF8&seller=A265O6I0NWO52E&asin=B088N7GSV5&ref_=dp_merchant_link&isAmazonFulfilled=1
    let seller_id = '';
    let seller_url_arr = seller_url.split('&');
    for (let i=0;i<seller_url_arr.length;i++){
        if(seller_url_arr[i].indexOf('seller=') !=-1){
            seller_id = seller_url_arr[i].replace('seller=','');
            break;
        }
    }
    return seller_id;
}

function plugin_set_expire(expire,callback){
    chrome.storage.local.set({expire: expire}, callback);
}

function plugin_get_expire(callback){
    chrome.storage.local.get('expire', callback);
}

function pause_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause: 0}, callback);
            }else{
                chrome.storage.local.set({pause: 1}, callback);
            }
        }
    });
}

function pause_page_switch(callback){
    chrome.storage.local.get(null, function(items) {
        //
        let prefix = 'pause_page';
        if (!items.hasOwnProperty(prefix)) {
            chrome.storage.local.set({pause_page: 1}, callback);
        }else{
            if(items[prefix] == 1){
                chrome.storage.local.set({pause_page: 0}, callback);
            }else{
                chrome.storage.local.set({pause_page: 1}, callback);
            }
        }
    });
}

function pause_s_time(){
    chrome.storage.local.get(null, function(items) {
        //
        chrome.storage.local.set({pause_s_time: Date.now()});
    });
}
//
function ajax_get(url){
    console.log('url:'+url);
    let _html_result = '';
    var exhibitors_ajax = $.ajax({
             //url: 'https://www.google.com/maps/place/VIP+Wigs+%26+Prosthesis/@37.9009282,-122.0623831,17z/data=!3m1!4b1!4m6!3m5!1s0x808561953bedbbfd:0xe9365860131da46b!8m2!3d37.9009282!4d-122.0623831!16s%2Fg%2F1tcxpx4r?authuser=0&hl=en',
             url:url,
             data: {},
             type: 'GET',
             async:false,
             crossDomain: true,
             //timeout:20000,//20 s
             dataType: 'html',
             contentType:'text/html; charset=utf-8',
             //dataType: 'json',
             //contentType:'application/json;charset=utf-8',
             success: function(data) {
                 _html_result = data;
             },
             error: function(xhr, textStatus, errorThrown) {
                _html_result = 'error';
            }
         });
    return _html_result;
}
//
function get_emails_filter(emails = []){
    var forbidden_keys = ['1.8.1','.cart', '.index', '.collection',
            '.js', 'template.404','tel:', 'mailto:', '.jpg', '.pdf', '.doc',
            '.xls', '.xlsx', '.png', '.jpeg', '.webp', '.gif', 'javascript:',
            'skype', '#', 'None', '.svg', 'desktop.ts', 'example', 'css', '.studio', 'image', 'jquery', 'swiper', 'myshopline.com',
            'img_', 'xxx.xxx', 'foundation-sites', 'exemple@mail.com', 'exemple@gmail.be', 'exemple@mail.ch', 'john@email.com',
            'your.email@address.com', 'stores@domain.com', 'test@email.com', 'first.last@company.com', 'you@email.com', 'your-email@shopify.com',
            'ada@ada.lt', 'johndoe@domain.com', 'your@email.com', 'jane.smith@email.com', 'abc@xyz.com', 'user@domain.com', 'template.account@template.blog',
            'john@test.com', 'emily@test.com', 'email@domain.com', 'yourname@email.com', 'jill@mail.com', 'joebloggs@email.com', 'abc@abc.abc', 'support@domain.com', 'yellow@hello.com'];
    var domain_emails = [];
    if(emails && emails.length>0){
        for(j=0;j<emails.length;j++){
            var current_email = emails[j];
            current_email = current_email.toLowerCase().trim();
            //把字符串最后一个.移除掉
            if(current_email[current_email.length-1] == '.'){
                current_email = current_email.slice(0,-1);
            }
            //排除有些如 .png
            var is_forbidden = false;
            for(k=0;k<forbidden_keys.length;k++){
                if(current_email.indexOf(forbidden_keys[k])!=-1){
                    is_forbidden = true;
                    break;
                }
            }
            //leaflet@1.8.0
            let current_email_arr = current_email.split('@');
            if(current_email_arr.length > 1){
                let current_a_houzhui = current_email_arr[1];
                let current_a_houzhui_arr = current_a_houzhui.split('.');
                let is_num_shuliang = 0;
                for(let k=0;k<current_a_houzhui_arr.length;k++){
                    if(util_isnumber(current_a_houzhui_arr[k])){
                        is_num_shuliang +=1;
                    }
                }
                if(is_num_shuliang >=2){
                    is_forbidden = true;
                }
            }
            //
            if(!is_forbidden && !domain_emails.includes(current_email)){
                domain_emails.push(current_email);
            }
            //
        }
    }
    return domain_emails;
}
//
function storage_shangjia_item_url_set(_shangjia_info={},local_num=1, callback){
    //
    if(typeof _shangjia_info['shangjia_item_url'] == 'undefined'){
        return;
    }
    if(_shangjia_info['shangjia_item_url'].indexOf('undefined') != -1){
        return;
    }
    //
    let _shangjia_item_url = _shangjia_info['shangjia_item_url'];
    let _shangjia_item_url_arr = _shangjia_item_url.split('?');
    let prefix = 'shangjia_shangjia_item_url_'+$.md5(_shangjia_item_url_arr[0]);
    //
    chrome.storage.local.get(null, function(items) {
        let total_add_shangjia_num = 0;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') > -1){
                total_add_shangjia_num += 1;
            }
        }
        total_add_shangjia_num = total_add_shangjia_num + local_num;
        //
        if(!items.hasOwnProperty(prefix)){
            let obj = {};
            obj[prefix] = {
                '_shangjia_item_url': _shangjia_info['shangjia_item_url'],
                '_is_request':0,
                '_store_name': '',
                '_store_url': '',
                '_shipping_from': '',

                '_seller_id': '',
                '_seller_is_repeat': 0,
                '_seller_name':'',
                '_seller_url':'',
                '_seller_url_is_request':0,

                '_seller_about':'',
                '_seller_detail':'',
                '_seller_contact_name':'',
                '_seller_phone': '',

                '_seller_country': '',
                '_seller_website': '',
                '_seller_company_name': '',
                '_seller_trn': '', //统一社会信用码
                '_seller_vat': '', //vat
                '_seller_sheng': '',
                '_seller_city': '',
                '_seller_address':'',
                '_seller_email': '',

                '_listing_num': 0,
                '_reivew_num': 0,
                '_main_category': '',

                '_product_name': '',
                '_product_url': '',
                '_product_img': '',

                'num':(total_add_shangjia_num+1)
            };
            chrome.storage.local.set(obj, callback);
        }
        //
    });
    //
}
//
function request_shangjia_item_url_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        let _shangjia_item_url = need_item['_shangjia_item_url'];
        console.log('request_shangjia_item_url_ajax:'+_shangjia_item_url);
        let _shangjia_item_url_four_character = _shangjia_item_url.slice(0,4);
        if(_shangjia_item_url.indexOf('/dp/')==-1 || _shangjia_item_url.indexOf('javascript')!=-1 || _shangjia_item_url_four_character !='http' || _shangjia_item_url.indexOf('amazon-adsystem') != -1){
            need_item['_seller_url_is_request'] = 2;
            need_item['_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
                //
                //
            });
            //
            return false;
        }
        //
        $.ajax({
            url:need_item['_shangjia_item_url']+'&psc=1',
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               let _dom = $(data);
               /**
                '_is_request':0,
                '_store_name': '',
                '_store_url': '',
                '_shipping_from': '',

                '_seller_name':'',
                '_seller_url':'',
                '_seller_url_is_request':0,

                '_seller_about':'',
                '_seller_detail':''
                 */
               //
                let _shangjia_item_url = need_item['_shangjia_item_url']
                let current_url = _shangjia_item_url.replace('https://','');
                let current_url_arr = current_url.split('/');
                let current_amz_site = 'https://'+current_url_arr[0];
                //

                let _store_name = _dom.find('a#bylineInfo').text();
                _store_name = _store_name.replace('Visit the','');
                _store_name = _store_name.replace('Store','');
                _store_name = _store_name.trim();
                //
                need_item['_store_name'] = _store_name;
                //
                let _productTitle = _dom.find('#productTitle').text();
                //
                if(need_item['_store_name'] || _productTitle){
                    need_item['_store_url'] = current_amz_site+_dom.find('a#bylineInfo').attr('href');
                    //
                    let _shipping_from = _dom.find('#fulfillerInfoFeature_feature_div .offer-display-feature-text:eq(0)').text();
                    _shipping_from = _shipping_from.trim();
                    need_item['_shipping_from'] = _shipping_from;
                    //
                    _seller_name = _dom.find('a#sellerProfileTriggerId:eq(0)').text();
                    _seller_name = _seller_name.trim();
                    need_item['_seller_name'] = _seller_name;
                    //
                    let _seller_url = _dom.find('a#sellerProfileTriggerId:eq(0)').attr('href');
                    if(_seller_url){
                        need_item['_seller_url'] = current_amz_site+_seller_url;
                    }
                    //get seller id
                    need_item['_seller_id'] = get_seller_id_from_url(need_item['_seller_url']);
                    //
                    let _product_name = _dom.find('#productTitle').text();
                    _product_name = _product_name.trim();
                    need_item['_product_name'] = _product_name;
                    let product_url = need_item['_shangjia_item_url'];
                    let product_url_arr = product_url.split('?');
                    if(product_url_arr.length > 0){
                        product_url = product_url_arr[0];
                    }
                    need_item['_product_url'] = product_url;
                    //
                    need_item['_product_img'] = _dom.find('#imgTagWrapperId img').attr('src');
                    //main_category
                    let main_category = '';
                    _dom.find('#wayfinding-breadcrumbs_feature_div li').each(function (){
                        let _category_item = $(this).find('a').text();
                        _category_item = _category_item.trim();
                        main_category += _category_item + '|';
                    });
                    if(main_category){
                        main_category = main_category.slice(0,-1);
                        need_item['_main_category'] = main_category;
                    }
                    if(main_category == ''){
                        //获取bestseller中的类目
                        let _product_bestseller_rank_name = '';
                        //
                        _dom.find('#productDetails_detailBullets_sections1 tr').each(function (){
                            let _td_a = $(this).find('td a:eq(0)').attr('href');
                            if(_td_a && _td_a.indexOf('bestsellers')!=-1){
                                //
                               _dom.find('td span span').each(function (){
                                    //
                                    let _last_bestseller_rank = $(this).text();
                                    if(_last_bestseller_rank.indexOf('in')!=-1 && _last_bestseller_rank.indexOf('#')!=-1 && _last_bestseller_rank.indexOf('(')==-1){
                                        _last_bestseller_rank = _last_bestseller_rank.trim();
                                        _last_bestseller_rank_arr = _last_bestseller_rank.split('in');
                                        if(_last_bestseller_rank_arr.length > 1){
                                            _product_bestseller_rank_name = _last_bestseller_rank_arr[1];
                                            _product_bestseller_rank_name = _product_bestseller_rank_name.trim();
                                        }
                                        return false;
                                        //
                                    }
                                    //
                               });
                                //
                            }
                        });
                        //
                        main_category = _product_bestseller_rank_name;
                        need_item['_main_category'] = main_category;
                        //
                    }
                    //
                    //
                    need_item['_is_request'] = 2;
                    //
                    chrome.storage.local.get(null, function(items) {
                        let seller_id_prefix = 'shangjia_seller_id_'+$.md5(need_item['_seller_id']);
                        //对于卖家已做了去重
                        if(need_item['_seller_url'] && need_item['_seller_url'].indexOf('undefined') ==-1 && need_item['_seller_id']!='' && !items.hasOwnProperty(seller_id_prefix)){
                            //
                            let shangjia_seller_obj = {};
                            shangjia_seller_obj[seller_id_prefix] = {
                                '_seller_id': need_item['_seller_id'],
                            };
                            chrome.storage.local.set(shangjia_seller_obj, function (){});
                            //
                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                                //
                                //
                            });
                        }else{
                            //
                            need_item['_seller_url_is_request'] = 2;
                            if(items.hasOwnProperty(seller_id_prefix)){
                                need_item['_seller_is_repeat'] = 1;
                            }
                            need_item['_store_name'] = '';
                            need_item['_store_url'] = '';
                            need_item['_shipping_from'] = '';
                            need_item['_seller_name'] = '';
                            need_item['_seller_url'] = '';

                            let obj = {};
                            obj[storage_key] = need_item;
                            chrome.storage.local.set(obj, function (){
                                //
                                //
                            });
                            //
                        }
                        //
                    });
                }else{
                    //
                    //
					let _data_category =  _dom.find("#nav-subnav").attr('data-category');
					console.log('_data_category:'+_data_category);
					//
                    if(data.indexOf('Amazon Music')!=-1 || _data_category == 'mobile-apps'){
                        need_item['_is_request'] = 2;
						need_item['_seller_url_is_request'] = 2;
                    }else{
                       //查看是否是出现验证页了
                        let _g = _dom.find('#g').attr('id');
                        if(_g && _g == 'g'){
                            need_item['_is_request'] = 0;
                            pause_s_time();
                            sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                        }else{
                            //need_item['_is_request'] = 2;
                            //need_item['_seller_url_is_request'] = 2;
                            //莫名的一些网址采集不到
                            need_item['_is_request'] = 0;
                            pause_s_time();
                            sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                            //
                        }
                    }
                    //
                    need_item['_error'] = '';
                    let obj = {};
                    obj[storage_key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        //
                    });
                }
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                console.log('jqXHR statue:'+jqXHR.status)
                //
                if(jqXHR.status == '404'){
                     need_item['_is_request'] = 2;
                     need_item['_seller_url_is_request'] = 2;
                }else{
                    need_item['_is_request'] = 0;
                }
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                    //
                    //
                });
                if(jqXHR.status != '404'){
                    pause_s_time();
                    sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                    //
                }
            }
        });
        //
    })
}

function request_shangjia_ajax_get_products_num(storefront_product_list_url=''){
    //
    console.log('request_shangjia_ajax_get_products_num');
    console.log(storefront_product_list_url);
    let products_num = 0;
    $.ajax({
            url:storefront_product_list_url,
            timeout : 5000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:false,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
                let _dom = $(data);
                //
                let products_num_str = _dom.find('h1.s-desktop-toolbar span').text();
                if(products_num_str){
                    products_num_str = products_num_str.replace(/\D/g, '_');
                }
                let products_num_arr = products_num_str.split('_');
                let products_num_arr_size = products_num_arr.length;
                let max_i = products_num_arr_size-1;
                for(let i=max_i;i>=0;i--){
                    let row_item = products_num_arr[i];
                    row_item = row_item.trim();
                    let row_item_int = parseInt(row_item);
                    if(row_item_int>0){
                        products_num = row_item_int;
                        break;
                    }
                }
            },
            error: function( jqXHR, textStatus, errorThrown ) {

            }
    });
    console.log(products_num);
    return products_num;
    //
}

function request_shangjia_item_url(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                if(items[key]['_is_request'] == 0 || (items[key]['_is_request'] == 1 && items[key]['_s_time'] < (Date.now()-8000))){
                    need_item = items[key];
                    need_item['_is_request'] = 1;
                    need_item['_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_item_url_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

//
function request_shangjia_seller_link_ajax(storage_key=''){
    chrome.storage.local.get(null, function(items) {
        let need_item = items[storage_key];
        let _seller_url = need_item['_seller_url'];
        console.log('request_shangjia_seller_link_ajax:'+_seller_url);
        let _seller_url_four_character = _seller_url.slice(0,4);
        if(_seller_url.indexOf('javascript')!=-1 || _seller_url_four_character!='http'){
            need_item['_seller_url_is_request'] = 2;
            let obj = {};
            obj[storage_key] = need_item;
            chrome.storage.local.set(obj, function (){
                //
                //
            });
            //
            return false;
        }
        //
        $.ajax({
            url:need_item['_seller_url'],
            timeout : 30000, //超时时间设置，单位毫秒
            data: {},
            type: 'GET',
            async:true,
            dataType: 'html',
            contentType:'text/html; charset=utf-8',
            crossDomain: true,
            cache: false,
            success: function(data) {
               var $html = $(data);
               //
                /*
                _seller_about
                _seller_detail
                 */
               need_item['_seller_about'] = $html.find('#spp-expander-about-seller').text();
               if(need_item['_seller_about']){
                    //
                   let emails  = extractEmails(need_item['_seller_about']);
                   if(emails && emails.length>0){
                       need_item['_seller_email'] = emails[0];
                   }
                   let _about_phone = selectPhoneNumber(need_item['_seller_about']);
                   //
                    let _seller_detail = $html.find('#page-section-detail-seller-info').text();
                   _seller_detail = _seller_detail.replace('Detailed Seller InformationBusiness Name:','');
                   _seller_detail = _seller_detail.trim();
                   need_item['_seller_detail'] = _seller_detail;
                   //
                   if(need_item['_seller_email']==''){
                       emails  = extractEmails(_seller_detail);
                       if(emails && emails.length>0){
                           need_item['_seller_email'] = emails[0];
                       }
                   }
                   //
                   //
                    let seller_url = need_item['_seller_url'];
                    seller_url = seller_url.replace('https://','');
                    let seller_url_arr = seller_url.split('/');
                    let current_amz_site = 'https://'+seller_url_arr[0];

                    if(current_amz_site.indexOf('amazon.co.jp') != -1){
                        //
                        need_item['_seller_country'] = $html.find('#page-section-detail-seller-info .a-row:eq(-3)').text();
                        need_item['_seller_phone'] = $html.find('#seller-contact-phone').text();
                       //
                        let seller_company_name = $html.find('#page-section-detail-seller-info .a-row:eq(1)').find('span:last-child').text();
                        if(seller_company_name){
                            seller_company_name = seller_company_name.trim();
                        }
                        need_item['_seller_company_name'] = seller_company_name;
                        let seller_sheng = $html.find('#page-section-detail-seller-info .a-row:eq(-5)').text();
                        if(seller_sheng){
                            seller_sheng = seller_sheng.trim();
                        }
                        need_item['_seller_sheng'] = seller_sheng;
                        need_item['_seller_company_name'] = seller_company_name;
                        let seller_city = $html.find('#page-section-detail-seller-info .a-row:eq(-6)').text();
                        if(seller_city){
                            seller_city = seller_city.trim();
                        }
                        need_item['_seller_city'] = seller_city;
                        let seller_address = $html.find('#page-section-detail-seller-info .a-row:eq(-8)').text();
                        if(seller_address){
                            seller_address = seller_address.trim();
                            //
                            let _seller_address2 = $html.find('#page-section-detail-seller-info .a-row:eq(-7)').text();
                            if(_seller_address2){
                                _seller_address2 = _seller_address2.trim();
                                seller_address +=' '+_seller_address2;
                            }
                            //
                        }
                        need_item['_seller_address'] = seller_address;
                        //
                        let seller_contact_name = $html.find('#page-section-detail-seller-info .a-row:eq(-2)').find('span:last-child').text();
                        seller_contact_name = seller_contact_name.trim();
                        need_item['_seller_contact_name'] = seller_contact_name;
                        //
                    }else{
                        need_item['_seller_country'] = $html.find('#page-section-detail-seller-info .a-row:last-child').text();
                        need_item['_seller_phone'] = $html.find('#seller-contact-phone').text();
                        if(need_item['_seller_phone'] ==''){
                            need_item['_seller_phone'] = _about_phone;
                        }
                        //
                        let seller_sheng = $html.find('#page-section-detail-seller-info .a-row:eq(-3)').text();
                        if(seller_sheng){
                            seller_sheng = seller_sheng.trim();
                        }
                        need_item['_seller_sheng'] = seller_sheng;

                        let seller_city = $html.find('#page-section-detail-seller-info .a-row:eq(-4)').text();
                        if(seller_city){
                            seller_city = seller_city.trim();
                        }
                        need_item['_seller_city'] = seller_city;
                       //
                        let seller_company_name = $html.find('#page-section-detail-seller-info .a-row:eq(1)').find('span:last-child').text();
                        if(seller_company_name){
                            seller_company_name = seller_company_name.trim();
                        }
                        //

                        //德国站、法国站
                        if(current_amz_site.indexOf('amazon.de') != -1 ||
                            current_amz_site.indexOf('amazon.fr') != -1 ||
                            current_amz_site.indexOf('amazon.es') != -1 ||
                            current_amz_site.indexOf('amazon.it') != -1 ||
                            current_amz_site.indexOf('amazon.se') != -1 ||
                            current_amz_site.indexOf('amazon.nl') != -1){
                             seller_company_name = $html.find('#page-section-detail-seller-info .a-row:eq(2)').find('span:last-child').text();
                             if(seller_company_name){
                                 seller_company_name = seller_company_name.trim();
                             }
                             //
                             let seller_trn = $html.find('#page-section-detail-seller-info .a-row:eq(4)').find('span:last-child').text();
                             if(seller_trn) {
                                 need_item['_seller_trn'] = seller_trn;
                             }
                             let seller_vat = $html.find('#page-section-detail-seller-info .a-row:eq(5)').find('span:last-child').text();
                             if(seller_vat) {
                                 need_item['_seller_vat'] = seller_vat;
                             }
                             if(current_amz_site.indexOf('amazon.it')!=-1){
                                 //
                                 $html.find('#page-section-detail-seller-info .a-row').each(function (){
                                     let _ds_name = $(this).find("span.a-text-bold").text();
                                     _ds_name = _ds_name.trim();
                                     if(_ds_name =='Numero di telefono:'){ //电话
                                        need_item['_seller_phone'] = $(this).find('span:last-child').text();
                                     }else if(_ds_name =='E-mail:'){
                                        need_item['_seller_email'] = $(this).find('span:last-child').text();
                                     }
                                 });
                                 //
                             }
                             //
                        }else if(current_amz_site.indexOf('amazon.co.uk') != -1){
                             //
                             let seller_trn = $html.find('#page-section-detail-seller-info .a-row:eq(3)').find('span:last-child').text();
                             if(seller_trn) {
                                 need_item['_seller_trn'] = seller_trn;
                             }
                             let seller_vat = $html.find('#page-section-detail-seller-info .a-row:eq(4)').find('span:last-child').text();
                             if(seller_vat) {
                                 need_item['_seller_vat'] = seller_vat;
                             }
                             //
                        }else if(current_amz_site.indexOf('amazon.pl') != -1){
                             seller_company_name = $html.find('#page-section-detail-seller-info .a-row:eq(2)').find('span:last-child').text();
                             if(seller_company_name){
                                 seller_company_name = seller_company_name.trim();
                             }
                             //
                             let seller_trn = $html.find('#page-section-detail-seller-info .a-row:eq(4)').find('span:last-child').text();
                             if(seller_trn) {
                                 need_item['_seller_trn'] = seller_trn;
                             }
                             let seller_vat = $html.find('#page-section-detail-seller-info .a-row:eq(5)').find('span:last-child').text();
                             if(seller_vat) {
                                 need_item['_seller_vat'] = seller_vat;
                             }
                             //
                            seller_sheng = $html.find('#page-section-detail-seller-info .a-row:eq(-4)').text();
                            if(seller_sheng){
                                seller_sheng = seller_sheng.trim();
                            }
                            need_item['_seller_sheng'] = seller_sheng;
                            //
                            seller_city = $html.find('#page-section-detail-seller-info .a-row:eq(-5)').text();
                            if(seller_city){
                                seller_city = seller_city.trim();
                            }
                            need_item['_seller_city'] = seller_city;
                            //
                            need_item['_seller_country'] = $html.find('#page-section-detail-seller-info .a-row:eq(-2)').text();
                        }else if(current_amz_site.indexOf('amazon.com.br') != -1 ||
                            current_amz_site.indexOf('amazon.eg') != -1){
                            //巴西、埃及
                            need_item['_seller_country'] = '';
                            need_item['_seller_sheng'] = '';
                            need_item['_seller_city'] = '';
                        }else if(current_amz_site.indexOf('amazon.com.tr') != -1){
                            //土耳其
                            if(need_item['_seller_country'] == 'CN'){
                                 //
                                 let seller_trn = $html.find('#page-section-detail-seller-info .a-row:eq(3)').find('span:last-child').text();
                                 if(seller_trn) {
                                     need_item['_seller_trn'] = seller_trn;
                                 }
                            }else{
                                //
                                need_item['_seller_vat'] = seller_company_name;
                                seller_company_name = '';
                                //
                            }
                            //
                        }else if(current_amz_site.indexOf('amazon.ae') != -1 || current_amz_site.indexOf('amazon.sa') != -1){
                            //阿联酉、沙特
                            need_item['_seller_country'] = '';
                            need_item['_seller_sheng'] = '';
                            need_item['_seller_city'] = '';
                        }
                        //
                        need_item['_seller_company_name'] = seller_company_name;


                        //
                        let seller_address = $html.find('#page-section-detail-seller-info .a-row:eq(3)').text();
                        if(seller_address){
                            seller_address = seller_address.trim();
                            //
                            let _seller_address2 = $html.find('#page-section-detail-seller-info .a-row:eq(4)').text();
                            if(_seller_address2){
                                _seller_address2 = _seller_address2.trim();
                                seller_address +=' '+_seller_address2;
                            }
                            //
                        }
                        need_item['_seller_address'] = seller_address;
                    }
                    //
                    let reivew_num = $html.find('#rating-year .ratings-reviews-count').text();
                    reivew_num = parseInt(reivew_num);
                    need_item['_reivew_num'] = reivew_num;
                    //

                    let storefront_product_list_url = current_amz_site+$html.find('#page-section-products a').attr('href');
                    let product_num = request_shangjia_ajax_get_products_num(storefront_product_list_url);
                    need_item['_listing_num'] = product_num;
                    //
                   //
                   need_item['_seller_url_is_request'] = 2;
               }else{
                   //查看是否是出现验证页了
                    let _g = $html.find('#g').attr('id');
                    if(_g && _g == 'g'){
                        need_item['_seller_url_is_request'] = 0;
                        pause_s_time();
                        sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_shangjia_item_url']);
                    }else{
                        need_item['_seller_url_is_request'] = 2;
                    }
               }

               let obj = {};
               obj[storage_key] = need_item;
               chrome.storage.local.set(obj, function (){
               });

               //
            },
            error: function( jqXHR, textStatus, errorThrown ) {
                console.log( jqXHR, textStatus, errorThrown );
                //
                need_item['_seller_url_is_request'] = 0;
                if(errorThrown == 'Not Found' || jqXHR.status == '404'){
                    need_item['_seller_url_is_request'] = 2;
                }
                //
                need_item['_error'] = errorThrown;
                let obj = {};
                obj[storage_key] = need_item;
                chrome.storage.local.set(obj, function (){
                    //
                    //
                });
                if(jqXHR.status != '404'){
                    pause_s_time();
                    sendPopTips("遇到反爬,请开启或者更换代理线路或者暂停采集，稍后再采集!", need_item['_seller_url']);
                }
            }
        });
        //
    })
}

function request_shangjia_seller_link(){
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                if(items[key]['_is_request'] == 2 &&
                    (items[key]['_seller_url_is_request'] ==0 || (items[key]['_seller_url_is_request'] == 1 && items[key]['_seller_url_s_time'] < (Date.now()-8000))  )){
                    need_item = items[key];
                    need_item['_seller_url_is_request'] = 1;
                    need_item['_seller_url_s_time'] = Date.now();
                    let obj = {};
                    obj[key] = need_item;
                    chrome.storage.local.set(obj, function (){
                        //
                        request_shangjia_seller_link_ajax(key);
                        //
                    });
                    break;
                }
            }
        }
        //
    });
}

function xintiao(){
    //request_company_shangjia_company_profile_link();
    //request_company_shangjia_contactinfo_link();
    //request_shangjia_company_page_link();
    chrome.storage.local.get(null, function(items) {
         if(!items.hasOwnProperty('pause') || items['pause'] == 0){
             if(items.hasOwnProperty('pause_s_time')  && (items['pause_s_time']+5000) > Date.now()){
                 console.log('因出现人机验证，暂停一会');
             }else{
                 console.log('爬取中');
                 request_shangjia_item_url();
                 request_shangjia_seller_link();
             }
         }else{
             console.log('已暂停爬取');
         }
    });
    //
    chrome.storage.local.get(null, function(items) {
        console.log('items');
        console.log(items);
    });

}
xintiao();
setInterval(xintiao, 5000);

function storage_clear(){
    /*plugin_get_expire(function (callback_data){
        let expire_date = callback_data['expire'];
        if(typeof expire_date != 'undefined'){
            chrome.storage.local.clear(function(){
                console.log('remove all');
                plugin_set_expire(expire_date);
            })
        }else{
            chrome.storage.local.clear(function(){
                console.log('remove all');
            })
        }
    });*/
    chrome.storage.local.get(null, function(items) {
        //
        let need_item = null;
        for (let key in items) {
            if (key.indexOf('shangjia_shangjia_item_url') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if (key.indexOf('shangjia_seller_id') != -1) {
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
            if(key == 'data_process'){
                // 清空特定值
                chrome.storage.local.remove(key, function() {
                   console.log(`键名 ${key} 的值已被清空！`);
                });
            }
        }
    });
}
//
function get_data_process(){

    let total_add_shangjia_num = 0;
    let has_caiji_shangjia_num = 0;

    chrome.storage.local.get(null, function(items) {
        //
        for(let key in items){
            if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                total_add_shangjia_num += 1;
                //if(items[key]['_is_request'] == 2 && items[key]['_seller_url_is_request'] == 2){
                if(items[key]['_seller_url_is_request'] == 2){
                    has_caiji_shangjia_num += 1;
                }
            }
        }
        //
        let obj = {};
        obj['data_process'] = {
            'total_add_shangjia_num': total_add_shangjia_num,
            'has_caiji_shangjia_num': has_caiji_shangjia_num
        }
        chrome.storage.local.set(obj, function (){
            //
            //
        });
        //
    });
}
//
function data_process_get(callback){
     /*chrome.storage.sync.get('domains', (res) => {
        console.log(res);
        return res;
     });*/
    chrome.storage.local.get('data_process', callback);
}

function storage_get(callback){
    chrome.storage.local.get(null, callback);
}

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if(request.action == 'shangjia_item_url_update'){
        console.log('action',request,sender,sendResponse);
        //
        let shangjia_infos = request.shangjia_infos;
        //
        for (let i=0;i<shangjia_infos.length;i++){
            storage_shangjia_item_url_set(shangjia_infos[i], (i+1), function (){

           });
        }
        //
        //request {action: "send", keyword: "keyword value"}
        //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
        //sendResponse  ƒ () { [native code] }
        sendResponse({state:'关键词填写成功！'});
    }else if(request.action  == 'can_zidong_caiji'){
        console.log('can_zidong_caiji',request,sender,sendResponse);
        //判断，如果加入超过3000个，则不能，而且需要已开启自动采集
        chrome.storage.local.get(null, function(items) {
            if(!items.hasOwnProperty('pause_page') || items['pause_page'] == 0){
                //已开启
                let total_add_shangjia_num = 0;
                for(let key in items){
                    if(key.indexOf('shangjia_shangjia_item_url_') != -1){
                        total_add_shangjia_num += 1;
                    }
                }
                if(total_add_shangjia_num < 3000){
                    sendResponse(JSON.stringify({state:0}));
                }else{
                    sendResponse(JSON.stringify({state:1}));
                }
                //
            }else{
                //已关闭
                sendResponse(JSON.stringify({state:1}));
            }
        });
        //
        return true;
    }
  }
);
function sendPopTips(msg = '', url=''){
     chrome.runtime.sendMessage({
        action: 'background-tips',
        info: msg,
         url:url,
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });
}

/**
 * 1.
 * chrome.runtime.onInstalled.addListener(details => {
  console.log('previousVersion', details.previousVersion);
});
2.
 //发送消息
 chrome.runtime.sendMessage({
        action: 'send',
        keyword: 'keyword value'
      }, function (response) {   //接收回调
        console.log(response);  //{state:'关键词填写成功！'}
      });

//监听扩展程序进程或内容脚本发送请求的请求
chrome.runtime.onMessage.addListener(
  function (request, sender, sendResponse) {
    if (request.action == 'send') {
      console.log('action',request,sender,sendResponse);
//  request {action: "send", keyword: "keyword value"}
 //sender  {id: "agkllkkjbhclhjnlebdbdagkagfgcecj", url: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj/popup.html", origin: "chrome-extension://agkllkkjbhclhjnlebdbdagkagfgcecj"}
//sendResponse  ƒ () { [native code] }
      sendResponse({state:'关键词填写成功！'});
    }
  }
);
 */
